unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, MathEdit;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button1: TButton;
    FloatEdit1: TFloatEdit;
    Label1: TLabel;
    FloatEdit2: TFloatEdit;
    Label2: TLabel;
    FloatEdit3: TFloatEdit;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FloatEdit1Exit(Sender: TObject);
    procedure FloatEdit2Exit(Sender: TObject);
    procedure FloatEdit3Exit(Sender: TObject);
  private
    { Private-Deklarationen }
    start,
    ende,
    schrittweite : Double;
    function myfunction (x: Double) : Double;
    procedure InitRange;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.InitRange;
  begin
  start := FloatEdit1.Value;
  ende  := FloatEdit2.Value;
  schrittweite := FloatEdit3.Value;
  end;

function TForm1.myfunction(x : Double) : Double;
  begin
  Result := x*x - x/2;
  end;

procedure TForm1.Button1Click(Sender: TObject);
  var x, y : Double;
      i, k : Integer;
  begin
  InitRange;
  k := Trunc((ende - start) / schrittweite) + 2;
  StringGrid1.RowCount := k;
  x := start;
  i := 1;
  While x < ende + schrittweite/2 do begin
    y := myFunction(x);
    StringGrid1.Cells[0, i] := FloatToStrF(x, ffGeneral, 3, 10);
    StringGrid1.Cells[1, i] := FloatToStrF(y, ffGeneral, 3, 10);
    x := x + schrittweite;
    i := i + 1;
    end;
  end;

procedure TForm1.FormCreate(Sender: TObject);
  begin
  InitRange;
  With StringGrid1 do begin
    Cells[0, 0] := '     x';
    Cells[1, 0] := '     f(x)';
    end;
  end;

procedure TForm1.FloatEdit1Exit(Sender: TObject);
  begin
  If FloatEdit2.Value < FloatEdit1.Value + 1 then
    FloatEdit2.Value := FloatEdit1.Value + 1;
  end;

procedure TForm1.FloatEdit2Exit(Sender: TObject);
  begin
  If FloatEdit1.Value > FloatEdit2.Value - 1 then
    FloatEdit1.Value := FloatEdit2.Value - 1;
  end;

procedure TForm1.FloatEdit3Exit(Sender: TObject);
  begin
  If FloatEdit3.Value < 1e-6 then
    FloatEdit3.Value := (FloatEdit2.Value - FloatEdit1.Value) / 10;
  end;

end.
